function playSFX(num, vol, posX)
{
   if(vol != 0 && !vol)
   {
      vol = 100;
   }
   if(posX)
   {
      v1 = Math.max(0,(400 - Math.abs(posX - (points[0].pos.x - 100))) / 4) * (vol / 100);
      v2 = Math.max(0,(400 - Math.abs(posX - (points[0].pos.x + 100))) / 4) * (vol / 100);
   }
   else
   {
      v1 = v2 = vol;
   }
   _root["sfxSound" + num].setTransform({ll:v1,lr:v1,rr:v2,rl:v2});
   _root["sfxSound" + num].start();
}
function getGroundHeight(x)
{
   if(Math.floor(x / 10) < 0)
   {
      return 0;
   }
   if(Math.floor(x / 10) >= lvlWidth)
   {
      return 0;
   }
   gh1 = GroundHeight[Math.floor(x / 10)];
   gh2 = GroundHeight[Math.floor(x / 10) + 1];
   v = x - Math.floor(x / 10) * 10;
   if(isNaN(gh1) || isNaN(gh2))
   {
      return GroundHeight[0];
   }
   return (gh1 * (10 - v) + gh2 * v) / 10;
}
function createEfx(n, x, y, vx, vy, xtra)
{
   curEfx++;
   curEfx %= maxEfx;
   efxLayer["Efx" + curEfx].setEfx(n);
   efxLayer["Efx" + curEfx].cur_x = x;
   efxLayer["Efx" + curEfx].cur_y = y;
   efxLayer["Efx" + curEfx]._xscale = efxLayer["Efx" + curEfx]._yscale = 100;
   if(vx || vy)
   {
      efxLayer["Efx" + curEfx].vel_x = vx;
      efxLayer["Efx" + curEfx].vel_y = vy;
   }
   else
   {
      efxLayer["Efx" + curEfx].vel_x = 0;
      efxLayer["Efx" + curEfx].vel_y = 0;
   }
   efxLayer["Efx" + curEfx].xtra = xtra;
}
function giveBonus(bonusName, bonusPoints)
{
   if(thisMS - lastBonusTS < 500)
   {
      bonusQue.push({bonusName:bonusName,bonusPoints:bonusPoints});
      bonusQueTimer = 15;
   }
   else
   {
      level_score = Math.max(0,level_score + bonusPoints);
      if(bonusPoints > 0)
      {
         createEfx(2,Stage.width / 2,Stage.height / 4,0,-4,bonusName + " " + bonusPoints);
      }
      else
      {
         createEfx(3,Stage.width / 2,Stage.height / 4,0,-4,bonusName + " " + bonusPoints);
      }
   }
   lastBonusTS = thisMS;
   flashTheScreen = 40;
}
function updateScroll()
{
   if(edit_enabled)
   {
      return undefined;
   }
   give = Stage.width / 6;
   ScrollOffX -= (ScrollOffX - points[0].vel.x * 7) / 10;
   ScrollOffY -= (ScrollOffY - points[0].vel.y * 5) / 10;
   screen_center_x = Stage.width / 2;
   screen_center_y = Stage.height / 2 + 40;
   scroll_x = (points[1].pos.x + points[2].pos.x) / 2 - screen_center_x + ScrollOffX;
   scroll_y = (points[1].pos.y + points[2].pos.y) / 2 - screen_center_y + ScrollOffY;
   lsx = scroll_x;
   lsy = scroll_y;
}
function newLevel(lvlWidth)
{
   var _loc3_ = new Array(lvlWidth);
   var _loc2_ = new Array(lvlWidth);
   var _loc4_ = new Array(lvlWidth);
   i = 1;
   while(i <= lvlWidth)
   {
      _loc3_[i] = 1000;
      _loc2_[i] = 1;
      if(Math.random() > 0.2)
      {
         SurfaceTiles[i] = 1;
      }
      i++;
   }
   i = 0;
   while(i <= 2)
   {
      points[i].velNext.x = points[i].vel.x = 0;
      points[i].velNext.y = points[i].vel.y = 0;
      i++;
   }
   points[0].rotVel = points[0].rotVelNext = 0;
}
function loadLevel(levelNumber)
{
   if(!levelLoaded)
   {
      levelLoaded = true;
      levelNumber = levelNumber - 1;
      lvlWidth = truckLevels[levelNumber].lvlWidth;
      objX = truckLevels[levelNumber].objX.split(",");
      objY = truckLevels[levelNumber].objY.split(",");
      objType = truckLevels[levelNumber].objType.split(",");
      i = 0;
      while(i < objX.length)
      {
         objX[i] = Number(objX[i]);
         objY[i] = Number(objY[i]);
         objType[i] = Number(objType[i]);
         initObj(i,objType[i]);
         i++;
      }
      newLevel(lvlWidth);
      lgh = 0;
      avgY = 0;
      i = 1;
      while(i <= lvlWidth)
      {
         GroundHeight[i] = convMD(truckLevels[levelNumber].GroundHeight.substr((i - 1) * 3,3));
         avgY += GroundHeight[i];
         i++;
      }
      i = 1;
      while(i <= lvlWidth)
      {
         SurfaceLayer[i] /= 20;
         randomGrass[i] = Math.round(Math.random());
         i++;
      }
      i = 1;
      while(i <= lvlWidth)
      {
         SurfaceRot[i - 1] = Math.atan2(GroundHeight[i] - lgh,10) * 57.2957795;
         n = Math.floor((Math.sqrt(100 + (GroundHeight[i] - lgh) * (GroundHeight[i] - lgh)) - 10) / 2) + 1;
         if(n == 1)
         {
            SurfaceTile[i - 1] = (Math.min(1,Math.ceil(SurfaceLayer[i])) + randomGrass[i]) * 20 + Math.floor(Math.random() * 9) + 1;
         }
         else
         {
            SurfaceTile[i - 1] = (Math.min(1,Math.ceil(SurfaceLayer[i])) + randomGrass[i]) * 20 + Math.floor(Math.random() * 9) + 11;
         }
         lgh = GroundHeight[i];
         i++;
      }
      avgY /= lvlWidth;
   }
   moveTruckTo(objX[0]);
   lastStuntX = 0;
   game_running = true;
   GameState = 2;
   GoText._alpha = 100;
   _root.points[0].rotPos = _root.points[0].rotPosNext = rotForBonus = start_rot = 0;
   rightNow = new Date();
   startBonusTime = rightNow.getTime() + 3000;
   maxBonusY = 10000;
   levelScoreAtBeginning = level_score;
   fadeInTheScreen = 300;
   _root.points[0].grounded = false;
   body.gotoAndStop(1);
}
function updateObjects()
{
   i = 1;
   while(i < objX.length)
   {
      objects["obj" + i]._x = objX[i] - scroll_x;
      objects["obj" + i]._y = objY[i] - scroll_y;
      i++;
   }
}
function initObj(objNum, objType)
{
   if(objType > 1)
   {
      objects.obj1.duplicateMovieClip("obj" + objNum,objNum + 2);
   }
   if(objType > 0)
   {
      objects["obj" + objNum].gotoAndStop(objType);
   }
}
function convMD(s)
{
   return ((s.charCodeAt(0) & 255) - 48) * 4096 + ((s.charCodeAt(1) & 255) - 48) * 64 + ((s.charCodeAt(2) & 255) - 48);
}
function formatMinSec(s)
{
   sec = s % 60;
   min = (s - sec) / 60;
   if(String(sec).length == 1)
   {
      return min + ":0" + sec;
   }
   return min + ":" + sec;
}
function showNormalMessage(m, pauseIt, lostLife)
{
   engineSpeed = 0;
   engineLoad = 0;
   normalMessage.messageText.text = m;
   normalMessage._visible = true;
   showNormalMessagefadeCnt = 100;
   if(pauseIt)
   {
      pauseUntilSpaceBar = true;
      normalMessage.messageText.text += " Press SPACE BAR to continue";
      normalMessage.messageText._y = 160 - normalMessage.messageText.textHeight;
      normalMessageMaxDown = normalMessage.messageText.textHeight - 110;
   }
   if(lostLife)
   {
      _root.playSFX(18);
      initCargo(9);
      lostLifeSet = true;
   }
}
function moveTruckTo(x)
{
   diffX = x - points[0].pos.x;
   diffY = getGroundHeight(x) - 10 - points[0].pos.y;
   i = 0;
   while(i <= 2)
   {
      with(points[i])
      {
         pos.x += diffX;
         pos.y += diffY;
         if(i == 1)
         {
            pos.x = points[0].pos.x - tireSpacing;
            pos.y = points[0].pos.y;
         }
         else if(i == 2)
         {
            pos.x = points[0].pos.x + tireSpacing;
            pos.y = points[0].pos.y;
         }
         posNext.x = pos.x;
         posNext.y = pos.y;
         velNext.x = vel.x = velNext.y = vel.y = 0;
         accNext.x = acc.x = accNext.y = acc.y = 0;
      }
      i++;
   }
   last_truck_grounded = truck_grounded;
}
lastStuntX = 0;
scroll_x = 0;
scroll_y = 800;
GameState = 0;
boostCharge = 0;
boostRelease = 0;
boostDownLast = false;
score = 0;
ticker = 0;
level_time = 0;
level_score = 0;
gameEndType = 1;
last_truck_grounded = false;
truck_grounded = false;
lastBonusTS = 0;
curCheckpoint = 2;
lostLifeSet = false;
pauseForInfo = false;
pauseUntilEnterKey = false;
showNormalMessagefadeCnt = 0;
game_running = false;
curLevel = 1;
WaitFor = 0;
Invincible = 0;
Lives = 5;
RoofHitCounter = 0;
upsideDown = false;
rollOverMessage._visible = false;
if(maxCargo != 8)
{
   maxCargo = 8;
   i = 1;
   while(i < 8)
   {
      cargo0.duplicateMovieClip("cargo" + i,i + 400 - maxCargo);
      i++;
   }
   createEmptyMovieClip("phTruckbody",maxCargo + 403);
   body.swapDepths(maxCargo + 403);
   createEmptyMovieClip("phTruckTire1",maxCargo + 404);
   tire1.swapDepths(maxCargo + 404);
   createEmptyMovieClip("phTruckTire2",maxCargo + 405);
   tire2.swapDepths(maxCargo + 405);
   createEmptyMovieClip("phwheelShine1",maxCargo + 406);
   wheelShine1.swapDepths(maxCargo + 406);
   createEmptyMovieClip("phwheelShine2",maxCargo + 407);
   wheelShine2.swapDepths(maxCargo + 407);
   i = 1;
   while(i <= maxEfx)
   {
      efxLayer.Efx0.duplicateMovieClip("Efx" + i,i + 410 + maxCargo);
      i++;
   }
   createEmptyMovieClip("phobjects",maxCargo + 450);
   objects.swapDepths(maxCargo + 450);
   createEmptyMovieClip("phnormalMessage",maxCargo + 451);
   normalMessage.swapDepths(maxCargo + 451);
   createEmptyMovieClip("phcheckPointScore",maxCargo + 452);
   checkPointScore.swapDepths(maxCargo + 452);
   createEmptyMovieClip("phfadeLayer",maxCargo + 454);
   fadeLayer.swapDepths(maxCargo + 454);
   createEmptyMovieClip("phstatusArea",maxCargo + 455);
   statusArea.swapDepths(maxCargo + 455);
   createEmptyMovieClip("debug_line",maxCargo + 1000);
   i = 0;
   while(i < soundEfx.length)
   {
      _root["sfxSound" + i] = new Sound(_root.createEmptyMovieClip("sfx" + i,maxCargo + i + 1002));
      _root["sfxSound" + i].attachSound(soundEfx[i]);
      i++;
   }
}
this.onEnterFrame = function()
{
   objects_in_truck_ac = objects_in_truck;
   objects_in_truck = 0;
   switch(GameState)
   {
      case 0:
         loadLevel(curLevel);
         GameState = 2;
         LevelEnd._visible = false;
         GoText._alpha = 0;
         statusArea.LivesDisplay.text = "x" + Lives;
         RoofHitCounter = 0;
         rollOverMessage._visible = false;
         initCargo(-1);
         statusArea.controls._visible = true;
         break;
      case 2:
         if(points[0].pos.x > objX[curCheckpoint])
         {
            moveTruckTo(points[0].pos.x);
            killEngine();
            initCargo(curCheckpoint - 2);
            curCheckpoint++;
            body.body_bg.steakbed._visible = curCheckpoint != 4 && curCheckpoint != 8;
         }
         if(fadeInTheScreen > 0)
         {
            fadeInTheScreen -= 5;
            fadeLayer.clear();
            if(fadeInTheScreen > 0)
            {
               fv = 255 - Math.min(255,fadeInTheScreen);
               fadeLayer.beginFill(fv * 65536 + fv * 256 + fv,100);
               fadeLayer.moveTo(0,0);
               fadeLayer.lineTo(480,0);
               fadeLayer.lineTo(480,384);
               fadeLayer.lineTo(0,384);
               fadeLayer.endFill();
               fadeLayer._visible = true;
            }
            else
            {
               fadeLayer.beginFill(0);
               fadeLayer.moveTo(0,0);
               fadeLayer.lineTo(480,0);
               fadeLayer.lineTo(480,384);
               fadeLayer.lineTo(0,384);
               fadeLayer.endFill();
               fadeLayer._visible = false;
            }
         }
         if(pauseUntilSpaceBar || pauseForInfo)
         {
            if(!pauseForInfo)
            {
               normalMessage._y += (normalMessageMaxDown - normalMessage._y) / 5;
               normalMessage._visible = true;
            }
            if(Key.isDown(32) && !pauseForInfo)
            {
               if(curCheckpoint > 10)
               {
                  killEngine();
                  GameState = 6;
                  _global.yourScore = level_score;
                  gotoAndStop("SubmitScoreFR");
                  play();
               }
               else if(lostLifeSet)
               {
                  Lives--;
                  if(Lives < 0)
                  {
                     killEngine();
                     _root.playSFX(17);
                     GameState = 6;
                     _global.yourScore = level_score;
                     gotoAndStop("GameOverFR");
                  }
                  statusArea.LivesDisplay.text = "x" + Lives;
                  body.gotoAndStop(1);
                  moveTruckTo(objX[curCheckpoint - 1]);
                  initCargo(curCheckpoint - 3);
               }
               else
               {
                  _root.playSFX(10);
                  _root.startEngine();
               }
               boostCharge = 0;
               pauseUntilSpaceBar = false;
            }
         }
         else
         {
            if(showNormalMessagefadeCnt > 0 && fadeInTheScreen > 0)
            {
               normalMessage._visible = true;
            }
            else if(showNormalMessagefadeCnt > 0)
            {
               normalMessage._visible = true;
               normalMessage._y = -138 + showNormalMessagefadeCnt * 1.38 + normalMessageMaxDown;
               showNormalMessagefadeCnt -= 5;
            }
            else
            {
               normalMessage._visible = false;
               normalMessage._y = -138;
            }
            if(GoText._alpha > 0)
            {
               GoText._alpha -= 5;
            }
            if(edit_enabled)
            {
               edit_onEnterFrame();
            }
            if(!game_running)
            {
               return undefined;
            }
            if(ticker % 30 == 29 && level_time > 0)
            {
               level_time -= 1;
            }
            ticker++;
            if(level_time == 0 && curCheckpoint > 2)
            {
               showNormalMessage("You have run out of time. Start over from the last checkpoint.",true,true);
            }
            i = curCheckpoint - 1;
            while(i <= curCheckpoint)
            {
               dist = objX[i] - points[0].pos.x;
               if(Math.abs(dist) < 1000)
               {
                  setVolume = "";
                  switch(i)
                  {
                     case 2:
                     case 8:
                     case 9:
                        if(sfxSound15.position == 0)
                        {
                           sfxSound15.start(0,5);
                        }
                        setVolume = "sfxSound15";
                        break;
                     case 3:
                        if(sfxSound14.position == 0)
                        {
                           sfxSound14.start(0,5);
                        }
                        setVolume = "sfxSound14";
                        break;
                     case 4:
                        if(sfxSound5.position == 0)
                        {
                           sfxSound5.start(0,20);
                        }
                        setVolume = "sfxSound5";
                        break;
                     case 6:
                        if(sfxSound16.position == 0)
                        {
                           sfxSound16.start(0,20);
                        }
                        setVolume = "sfxSound16";
                  }
                  if(setVolume)
                  {
                     v1 = Math.max(0,(400 - Math.abs(objX[i] - (points[0].pos.x - 100))) / 4);
                     v2 = Math.max(0,(400 - Math.abs(objX[i] - (points[0].pos.x + 100))) / 4);
                     _root[setVolume].setTransform({ll:v1,lr:v1,rr:v2,rl:v2});
                  }
               }
               i++;
            }
            brakes = 0;
            sDownLast = Key.isDown(83);
            if(Key.isDown(39))
            {
               control_rot = 0.022;
               bed_rot = 0.2;
            }
            else if(Key.isDown(37))
            {
               control_rot = -0.022;
               bed_rot = -0.2;
            }
            else
            {
               control_rot = 0;
               bed_rot = 0;
            }
            if(Key.isDown(38))
            {
               lr = 1;
               statusArea.controls._visible = false;
            }
            else if(Key.isDown(40))
            {
               lr = -1;
            }
            else
            {
               lr = 0;
            }
            if(Key.isDown(90))
            {
               if(Math.abs(lr))
               {
                  braking = 1;
                  lr *= 0.5;
               }
               else
               {
                  braking = 0.5;
               }
            }
            else
            {
               braking = 1;
            }
            if(Key.isDown(16) && !boostDownLast && truck_grounded)
            {
               boostDownLast = true;
               boostRelease = boostCharge;
               boostCharge = 0;
            }
            else if(!Key.isDown(16))
            {
               boostDownLast = false;
            }
            cargoPhysics();
            if(!(edit_enabled && mouseIsDown))
            {
               truckPhysics(1);
            }
            tot_bed_rot_vel = rotVel + bed_rot_vel;
            updateObjects();
            updateScroll();
            ground2._y = - scroll_y / 1.008;
            i = 0;
            while(i < Math.floor(Stage.width / 10) + 2)
            {
               if(ground2["surface" + i].xoff - scroll_x < -10)
               {
                  ground2["surface" + i].xoff += (Math.floor(Stage.width / 10) + 2) * 10;
                  ground2["surface" + i].tileUpdated = true;
               }
               if(ground2["surface" + i].xoff - scroll_x > (Math.floor(Stage.width / 10) + 1) * 10)
               {
                  ground2["surface" + i].xoff -= (Math.floor(Stage.width / 10) + 2) * 10;
                  ground2["surface" + i].tileUpdated = true;
               }
               if(ground2["surface" + i].tileUpdated)
               {
                  ground2["surface" + i].tileUpdated = false;
                  x = i * 10 - scroll_x % 10;
                  last_y = y;
                  y = getGroundHeight(ground2["surface" + i].xoff);
                  nextY = getGroundHeight(ground2["surface" + i].xoff + 10) - y;
                  n = Math.floor(Math.floor(ground2["surface" + i].xoff / 10));
                  ground2["surface" + i]._y = y;
                  if(_global.graphicsOptSet[4])
                  {
                     ground2["surface" + i].tile._visible = true;
                     ground2["surface" + i].tile._rotation = SurfaceRot[n];
                     ground2["surface" + i].tile.gotoAndStop(SurfaceTile[n - 1]);
                  }
                  else
                  {
                     ground2["surface" + i].tile._visible = false;
                  }
                  bgDraw = ground2["surface" + i].bgDraw;
                  bgDraw.clear();
                  if(_global.graphicsOptSet[3])
                  {
                     j = 0;
                     while(j <= 2)
                     {
                        Nj = 2 - j;
                        bgDraw.beginFill(layerColors[j]);
                        bgDraw.moveTo(0,Math.max(0,SurfaceLayer[n] - j) * (Nj * 50));
                        bgDraw.lineTo(11,nextY + Math.max(0,SurfaceLayer[n + 1] - j) * (Nj * 50));
                        if(j == 0)
                        {
                           bgDraw.lineTo(11,500);
                           bgDraw.lineTo(-1,500);
                        }
                        else
                        {
                           bgDraw.lineTo(11,nextY + Math.max(0,SurfaceLayer[n + 1] - j + 1) * ((Nj + 1) * 50));
                           bgDraw.lineTo(0,Math.max(0,SurfaceLayer[n] - j + 1) * ((Nj + 1) * 50));
                        }
                        j++;
                     }
                  }
                  else
                  {
                     bgDraw.beginFill(layerColors[0]);
                     bgDraw.moveTo(0,0);
                     bgDraw.lineTo(11,nextY + SurfaceLayer[n + 1]);
                     bgDraw.lineTo(11,500);
                     bgDraw.lineTo(-1,500);
                  }
                  bgDraw.endFill();
               }
               ground2["surface" + i]._x = ground2["surface" + i].xoff - scroll_x;
               i++;
            }
            body._x = _loc0_ = points[0].pos.x - scroll_x;
            body_bg._x = _loc0_;
            body._y = _loc0_ = points[0].pos.y - scroll_y;
            body_bg._y = _loc0_;
            tire1._x = _loc0_ = points[2].pos.x - scroll_x;
            wheelShine1._x = _loc0_;
            tire1._y = _loc0_ = points[2].pos.y - scroll_y;
            wheelShine1._y = _loc0_;
            thisRot = Math.max(_root.points[1].tireRot,_root.points[2].tireRot);
            tire2._rotation += thisRot;
            tire1._rotation = _loc0_;
            tire1.gotoAndStop(Math.floor(Math.abs(thisRot / 11.25)) + 1);
            tire2.gotoAndStop(Math.floor(Math.abs(thisRot / 11.25)) + 1);
            tire2._x = _loc0_ = points[1].pos.x - scroll_x;
            wheelShine2._x = _loc0_;
            tire2._y = _loc0_ = points[1].pos.y - scroll_y;
            wheelShine2._y = _loc0_;
            shocks.clear();
            i = 1;
            while(i <= 2)
            {
               shocks.lineStyle(4,3355443,100);
               shocks.moveTo(points[0].pos.x - scroll_x,points[0].pos.y - scroll_y);
               shocks.lineTo(points[i].pos.x - scroll_x,points[i].pos.y - scroll_y);
               i++;
            }
            statusArea.Time.text = formatMinSec(level_time);
            statusArea.Score.text = level_score;
            statusArea.CargoDisp.text = objects_in_truck_ac + " " + object_name;
            statusArea.boostBar.BoostBarGRPHX._width = boostCharge * 10;
            statusArea.boostBar.boostLabel._visible = boostCharge == 10;
         }
         break;
      case 3:
         LevelEnd.pressUpToCont._visible = false;
         LevelEnd._visible = true;
         LevelEnd.TimeBonus.text = "Time Bonus: " + timeBonus;
         statusArea.Score.text = level_score;
         WaitFor = 120;
         GameState++;
         break;
      case 4:
         WaitFor--;
         if(WaitFor == 0)
         {
            LevelEnd.pressUpToCont._visible = true;
         }
         if(WaitFor <= 0 || WaitFor <= 60 && Key.isDown(38))
         {
            GameState++;
         }
         break;
      case 5:
         curLevel++;
         GameState = 0;
         level_time = 0;
         game_running = false;
         if(curLevel == 11)
         {
            gameEndType = 1;
            gotoAndStop(13);
         }
   }
};
gotoAndStop(10);
